%global __os_install_post %{nil}
%global _find_debuginfo_opts -g

Summary:        High-level tracing language for Linux eBPF
Name:           bpftrace
Version:        0.19.1
Release:        4%{?dist}
License:        ASL 2.0

URL:            https://github.com/iovisor/bpftrace
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

Patch0001: CVE-2024-2313-Fix-security-hole-checking-unpacked-kernel-headers-3.patch

ExclusiveArch:  x86_64 ppc64le aarch64 loongarch64

BuildRequires:  gcc-c++ bison flex cmake
BuildRequires:  zlib-devel llvm-devel clang-devel elfutils-libelf-devel
BuildRequires:  libbpf-devel libbpf-static elfutils-devel bcc-devel >= 0.19.0-1
BuildRequires:  binutils-devel cereal-devel rubygem-asciidoctor


%description
BPFtrace is a high-level tracing language for Linux enhanced Berkeley Packet
Filter (eBPF) available in recent Linux kernels (4.x). BPFtrace uses LLVM as a
backend to compile scripts to BPF-bytecode and makes use of BCC for
interacting with the Linux BPF system, as well as existing Linux tracing
capabilities: kernel dynamic tracing (kprobes), user-level dynamic tracing
(uprobes), and tracepoints. The BPFtrace language is inspired by awk and C,
and predecessor tracers such as DTrace and SystemTap


%prep
%autosetup -p1


%build
%cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DBUILD_TESTING:BOOL=OFF \
       -DBUILD_SHARED_LIBS:BOOL=OFF \
       -DUSE_SYSTEM_BPF_BCC:BOOL=ON
%cmake_build


%install
%cmake_install

find %{buildroot}%{_datadir}/%{name}/tools -type f -exec \
  sed -i -e '1s=^#!/usr/bin/env %{name}\([0-9.]\+\)\?$=#!%{_bindir}/%{name}=' {} \;


%files
%license LICENSE
%doc README.md CONTRIBUTING-TOOLS.md
%doc docs/reference_guide.md docs/tutorial_one_liners.md
%{_bindir}/%{name}
%{_bindir}/%{name}-aotrt
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/tools
%dir %{_datadir}/%{name}/tools/doc
%dir %{_datadir}/%{name}/tools/old
%attr(0755,-,-) %{_datadir}/%{name}/tools/*.bt
%attr(0755,-,-) %{_datadir}/%{name}/tools/old/*.bt
%{_datadir}/%{name}/tools/doc/*.txt
%{_mandir}/man8/*


%changelog
* Thu May 30 2024 Pengda Dou <doupengda@loongson.cn> - 0.19.1-4
- [Type] other
- [DESC] add loongarch64 to ExclusiveArch

* Tue Apr 2 2024 luffyluo <luffyluo@tencent.com> - 0.19.1-3
- Update BuildRequires for parsing DWARF

* Thu Mar 14 2024 Chunsheng Luo <luffyluo@tencent.com> - 0.19.1-2
- Fix CVE-2024-2313

* Fri Dec 22 2023 Upgrade Robot <upbot@opencloudos.org> - 0.19.1-1
- Upgrade to version 0.19.1

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.18.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Jul 18 2023 kianli <kianli@tencent.com> - 0.18.0-3
- Rebuild with libbpf 1.2.0 after bcc rebuild

* Mon Jul 17 2023 kianli <kianli@tencent.com> - 0.18.0-2
- Rebuild with libbpf 1.2.0

* Thu Jun 29 2023 kianli <kianli@tencent.com> - 0.18.0-1
- Upgrade to 0.18.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.16.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.16.0-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Dec 29 2022 cunshunxia <cunshunxia@tencent.com> - 0.16.0-1
- initial build
